'''
CF-1.5 changes based on CF-1.4 checker code

implementation of requirements and recommendations from
http://cf-pcmdi.llnl.gov/documents/cf-conventions/cf-conventions-version-1.5/cf-conventions.html

this code is an extension of the CF-1.0 checker base code in the cf10 module
and the modifications by the CF-1.1, CF-1.2, CF-1.3 and CF-1.4 checker codes in the
cf11, cf12, cf13 and cf14 modules respectively
'''
import re, os, string

from CFchecker import cf14

class CF15Tests(cf14.CF14Tests):
    '''
    changes compared to 1.4:
        - restricted character set of flag_meanings phrases
    '''
    cf_convention = 'CF-1.5'
    # starting with CF-1.5, flag_meanings phrases may only contain alphanumeric characters and
    # the additional characters '_', '-', '.', '+', '@'
    _allowed_flag_meanings_chars = set(string.letters + string.digits + '_-.+@')
