'''
collection of CFchecker related errors/Exceptions
'''

class MessageLogOverflow(Exception):
    def __init__(self, messagelog, errormsg):
        super(MessageLogOverflow, self).__init__(errormsg)
        self.messagelog=messagelog

class CFCheckerError(Exception):
    pass

class CFAutoDetectError(CFCheckerError):
    pass

class CellMethodsParseError(CFCheckerError):
    pass

class StandardNameTableError(CFCheckerError):
    pass

class StandardNameTableNotFoundError(StandardNameTableError):
    pass

class StandardNameTableCorruptError(StandardNameTableError):
    pass

class AreaTypeTableError(CFCheckerError):
    pass

class AreaTypeTableNotFoundError(AreaTypeTableError):
    pass

class AreaTypeTableCorruptError(AreaTypeTableError):
    pass

class UnknownUnitsError(Exception):
    pass
