'''
nose unit tests for CFchecker.cf15
'''
import os

from nose import tools as nt

from CFchecker.cf15 import CF15Tests
import cf14_test
import helpers

class CF15Tests_test(cf14_test.CF14Tests_test):
    '''
    test 3.5 extension: invalid characters in flag_meanings
    '''
    test_class = CF15Tests

    @classmethod
    def setup_class(cls):
        cf14_test.CF14Tests_test.setup_class()
        helpers.amend_faulty_ncfile_cf15(os.path.join(cls.tempdir, cls.faulty_file))
        helpers.amend_good_ncfile_cf15(os.path.join(cls.tempdir, cls.good_file))

    def test_3_5_check(self):
        '''CF15Tests: test 3.5'''
        msgs = { self.faulty_file: [('ERROR', '3.5', 'casetest: flag_values attribute and variable need to have the same data type ' \
                                                     '(S <-> f)'),
                                    ('WARNING', '3.5', 'casetest: flag_* attributes found but status_flag modifier not set'),
                                    ('ERROR', '3.5', 'casetest: flag_meanings attribute should be a string'),
                                    ('ERROR', '3.5', 'CaseTest: flag_values and flag_meanings attributes have different lengths (3 <-> 7)'),
                                    ('ERROR', '3.5', 'CaseTest: flag_masks and flag_meanings attributes have different lengths (4 <-> 7)'),
                                    ('ERROR', '3.5', 'CaseTest: flag_masks attribute and variable need to have the same data type ' \
                                                     '(i <-> f)'),
                                    ('WARNING', '3.5', 'CaseTest: flag_* attributes found but status_flag modifier not set'),
                                    ('ERROR', '3.5', 'CaseTest: variable type must be compatible with bit field expressions (char, short, int, long)'),
                                    ('ERROR', '3.5', 'wrong_dim_order: flag_meanings attribute without flag_values or flag_masks attribute'),
                                    ('WARNING', '3.5', 'wrong_dim_order: flag_* attributes found but status_flag modifier not set'),
                                    ('ERROR', '3.5', "wrong_dim_order: flag_meanings phrase 'in*' contains invalid characters: '*'"),
                                    ('ERROR', '3.5', "wrong_dim_order: flag_meanings phrase 'flag#values' contains invalid characters: '#'"),
                                    ('ERROR', '3.5', "wrong_dim_order: flag_meanings phrase 'v=ar' contains invalid characters: '='"),
                                    ('ERROR', '3.5', "wrong_dim_order: flag_meanings phrase 'mis$in~g' contains invalid characters: '$', '~'"),
                                    ('ERROR', '3.5', 'double_dependency: flag_values attribute and variable need to have the same data ' \
                                                     'type (S <-> f)'),
                                    ('WARNING', '3.5', 'double_dependency: flag_* attributes found but status_flag modifier not set'),
                                    ('ERROR', '3.5', '_spam_data: flag_values attribute and variable need to have the same data type ' \
                                                     '(i <-> f)'),
                                    ('ERROR', '3.5', '_spam_data: flag_masks attribute and variable need to have the same data type ' \
                                                     '(i <-> f)'),
                                    ('ERROR', '3.5', '_spam_data: flag_values attribute without flag_meanings attribute'),
                                    ('ERROR', '3.5', '_spam_data: flag_masks attribute without flag_meanings attribute'),
                                    ('ERROR', '3.5', '_spam_data: variable type must be compatible with bit field expressions '
                                                     '(char, short, int, long)'),
                                    ('WARNING', '3.5', '_spam_data: flag_* attributes found but status_flag modifier not set'),
                                    ('ERROR', '3.5', '_spam_data: flag_masks attribute values must be non-zero'),
                                    ('WARNING', '3.5', '_spam_data: boolean AND of flag_values and flag_masks entries should equal flag_values entry'),
                                    ('ERROR', '3.5', 'double_dependency: flag_values and flag_meanings attributes have '
                                                     'different lengths (45 <-> 4)'),
                                    ('ERROR', '3.5', 'double_dependency: every flag_values value has to be unique within the set of all '
                                                     'flag_values'),
                                    ('ERROR', '3.5', 'casetest: every flag_values value has to be unique within the set of all '
                                                     'flag_values'),
                                    ('WARNING', '3.5', 'double_axis: boolean AND of flag_values and flag_masks entries should equal flag_values entry'),
                                    ('ERROR', '3.5', 'double_axis: flag_values attribute without flag_meanings attribute'),
                                    ('ERROR', '3.5', 'double_axis: flag_masks attribute without flag_meanings attribute'),
                                    ('WARNING', '3.5', 'double_axis: flag_* attributes found but status_flag modifier not set'),
                                      ],
                 self.good_file: [],
                }
        self.check_runner(msgs)
